# -*- coding: utf-8 -*-
# Generated by Django 1.11.29 on 2024-05-10 21:02
from django.db import migrations

import kolibri.core.auth.constants.demographics
import kolibri.core.fields
import kolibri.core.utils.validators


class Migration(migrations.Migration):

    dependencies = [
        ("kolibriauth", "0025_custom_demographic_schema"),
    ]

    operations = [
        migrations.AlterField(
            model_name="facilitydataset",
            name="extra_fields",
            field=kolibri.core.fields.JSONField(
                blank=True,
                default={"facility": {}, "on_my_own_setup": False, "pin_code": ""},
                null=True,
                validators=[
                    kolibri.core.utils.validators.JSON_Schema_Validator(
                        {
                            "properties": {
                                "demographic_fields": {
                                    "items": {
                                        "properties": {
                                            "description": {"type": "string"},
                                            "enumValues": {
                                                "items": {
                                                    "properties": {
                                                        "defaultLabel": {
                                                            "type": "string"
                                                        },
                                                        "translations": {
                                                            "items": {
                                                                "properties": {
                                                                    "language": {
                                                                        "enum": [
                                                                            "ar",
                                                                            "bg-bg",
                                                                            "bn-bd",
                                                                            "de",
                                                                            "el",
                                                                            "en",
                                                                            "es-419",
                                                                            "es-es",
                                                                            "fa",
                                                                            "ff-cm",
                                                                            "fr-fr",
                                                                            "gu-in",
                                                                            "ha",
                                                                            "hi-in",
                                                                            "ht",
                                                                            "id",
                                                                            "it",
                                                                            "ka",
                                                                            "km",
                                                                            "ko",
                                                                            "mr",
                                                                            "my",
                                                                            "ny",
                                                                            "pt-br",
                                                                            "pt-mz",
                                                                            "sw-tz",
                                                                            "te",
                                                                            "uk",
                                                                            "ur-pk",
                                                                            "vi",
                                                                            "yo",
                                                                            "zh-hans",
                                                                        ],
                                                                        "type": "string",
                                                                    },
                                                                    "message": {
                                                                        "type": "string"
                                                                    },
                                                                },
                                                                "type": "object",
                                                            },
                                                            "optional": True,
                                                            "type": "array",
                                                        },
                                                        "value": {"type": "string"},
                                                    },
                                                    "type": "object",
                                                },
                                                "type": "array",
                                            },
                                            "id": {"type": "string"},
                                            "translations": {
                                                "items": {
                                                    "properties": {
                                                        "language": {
                                                            "enum": [
                                                                "ar",
                                                                "bg-bg",
                                                                "bn-bd",
                                                                "de",
                                                                "el",
                                                                "en",
                                                                "es-419",
                                                                "es-es",
                                                                "fa",
                                                                "ff-cm",
                                                                "fr-fr",
                                                                "gu-in",
                                                                "ha",
                                                                "hi-in",
                                                                "ht",
                                                                "id",
                                                                "it",
                                                                "ka",
                                                                "km",
                                                                "ko",
                                                                "mr",
                                                                "my",
                                                                "ny",
                                                                "pt-br",
                                                                "pt-mz",
                                                                "sw-tz",
                                                                "te",
                                                                "uk",
                                                                "ur-pk",
                                                                "vi",
                                                                "yo",
                                                                "zh-hans",
                                                            ],
                                                            "type": "string",
                                                        },
                                                        "message": {"type": "string"},
                                                    },
                                                    "type": "object",
                                                },
                                                "optional": True,
                                                "type": "array",
                                            },
                                        },
                                        "type": "object",
                                    },
                                    "optional": True,
                                    "type": "array",
                                },
                                "facility": {"optional": True, "type": "object"},
                                "on_my_own_setup": {
                                    "optional": True,
                                    "type": "boolean",
                                },
                                "pin_code": {
                                    "optional": True,
                                    "type": ["string", "null"],
                                },
                            },
                            "type": "object",
                        }
                    ),
                    kolibri.core.auth.constants.demographics.UniqueIdsValidator(
                        "demographic_fields"
                    ),
                    kolibri.core.auth.constants.demographics.DescriptionTranslationValidator(
                        "demographic_fields"
                    ),
                    kolibri.core.auth.constants.demographics.EnumValuesValidator(
                        "demographic_fields"
                    ),
                    kolibri.core.auth.constants.demographics.LabelTranslationValidator(
                        "demographic_fields"
                    ),
                ],
            ),
        ),
    ]
